/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 * @author Anup Dhabarde
 */

var CdpDownload = function () {
	var config = {
		isDownloading: false,
		prompts: Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService),
		obj_Persist: null,
		cdpId: ''
	}
	
	/**
	 * 	Function to initilize download of book database from server.
	 */
	
	var init = function (cdpId, catalogId, downloadLink) {
		var self = this;
		
		if(config.isDownloading){
			// config.prompts.alert(null, AME.getTitle(), 'Another book download in progress. You can download only one book at a time.');
			AME.showMessage('Another book download in progress. You can download only one book at a time.', 'warning', true, null);
			document.getElementById("doc-viewer-azd").contentWindow.enableDownloadButton(cdpId);
			return;
		}
		
		var params = {
					inn:{
						cdpId: cdpId,
						catalogId: catalogId,
						downloadLink: downloadLink,
						type: 'download_url'
					},
					out:{
						out: null,
						download_url: null,
						error_message: null,
						raf: null
					}
				};
  		window.openDialog("chrome://azardi2/content/azd_modal_dialog.xul", "", "width=250, height=60, chrome, dialog, modal, resizable=yes, titlebar=no, dependent, centerscreen", params).focus();
    	
		if (!params.out.out) {
			// alert(params.out.error_message);
			AME.showMessage(params.out.error_message, 'warning', true, null);
			// TODO: Remove this if codition, and while removing book do not remove expiry date from RAF_Master
			// 		 Force the user to renew the book if it has expired.
			if(params.out.error_message == 'Subscription has Expired.'){
				Catalog.writeBookStatus(cdpId, 'expired');
				document.getElementById('doc-viewer-azd').contentWindow.hideDownloadButton(cdpId);
				document.getElementById('doc-viewer-azd').contentWindow.hideInstallButton(cdpId);
				document.getElementById('doc-viewer-azd').contentWindow.hideRemoveButton(cdpId);
				document.getElementById('doc-viewer-azd').contentWindow.hideReadButton(cdpId);
				document.getElementById("doc-viewer-azd").contentWindow.disableCoverRead(cdpId);
				document.getElementById('doc-viewer-azd').contentWindow.showExpireButton(cdpId);
  			}
  			else{
  				document.getElementById("doc-viewer-azd").contentWindow.enableDownloadButton(cdpId);
  			}
  			return;
		}
		
		config.isDownloading = true;
		// Set current downloading book cdpId.
		config.cdpId = cdpId;
		AME.showStatusBar();
		$('#download-progressbar').attr('mode', 'undetermined');
		var fileObj = getFileObject(AME.getTempDownloadPath());
  		fileObj.append(cdpId+'.azd');
  		var readerToken = AME.getReaderToken();
  		// Encrypt the expiry date
	  	var expiryDate = GibberishAES.enc(params.out.raf, readerToken+cdpId);
	  	self.downloadFile(fileObj.path, params.out.download_url, expiryDate);
	}
	
	var downloadFile = function (tempDownloadPath, httpLocation, expiryDate) {
		var self = this;
		
		try {
			var obj_URI = Components.classes["@mozilla.org/network/io-service;1"]
									.getService(Components.interfaces.nsIIOService)
									.newURI(httpLocation, null, null);
			
			var obj_TargetFile = Components.classes["@mozilla.org/file/local;1"]
										   .createInstance(Components.interfaces.nsILocalFile);
	
			obj_TargetFile.initWithPath(tempDownloadPath);
			
			//	Create the file if it doesn't exists.
			if(!obj_TargetFile.exists()) {
				obj_TargetFile.create(0x00,0644);
			}
	
			config.obj_Persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"]
									.createInstance(Components.interfaces.nsIWebBrowserPersist);
	
			const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
			const flags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
			config.obj_Persist.persistFlags = flags | nsIWBP.PERSIST_FLAGS_BYPASS_CACHE | nsIWBP.PERSIST_FLAGS_CLEANUP_ON_FAILURE;
	
			config.obj_Persist.progressListener = {
				onProgressChange: function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {
					if($('#download-progressbar').attr('mode') == 'undetermined'){
						$('#download-progressbar').attr('mode', 'determined');
					}
					var percentComplete = (aCurTotalProgress/aMaxTotalProgress)*100;
					$('#download-progressbar').attr('value', percentComplete);
				},
				
				onStateChange: function(aWebProgress, aRequest, aStateFlags, aStatus) {
					if(config.obj_Persist.currentState == config.obj_Persist.PERSIST_STATE_FINISHED) {
						var chan =	aRequest.QueryInterface(Components.interfaces.nsIHttpChannel);
						if (!chan.requestSucceeded) {
							config.isDownloading = false;
							// Reset current downloading book cdpId.
  							config.cdpId = '';
							AME.hideStatusBar();
							delete_Folder(tempDownloadPath);
							// config.prompts.alert(null, AME.getTitle(), "Book not available");
							AME.showMessage('The requested book is not available.', 'warning', true, null);
							document.getElementById("doc-viewer-azd").contentWindow.enableDownloadButton(httpLocation.split('/').pop().split('.')[0]);
							return;
						}
						if(aStatus == 0){		//		aStatus gives '0' if download is finished.
							config.isDownloading = false;
							// Reset current downloading book cdpId.
  							config.cdpId = '';
							
							AME.hideStatusBar();
							Catalog.writeBookStatus(httpLocation.split('/').pop().split('.')[0], 'downloaded');
							
							Catalog.writeBookExpiry(httpLocation.split('/').pop().split('.')[0], expiryDate);
							
							document.getElementById("doc-viewer-azd").contentWindow.hideDownloadButton(httpLocation.split('/').pop().split('.')[0]);
							document.getElementById("doc-viewer-azd").contentWindow.showInstallButton(httpLocation.split('/').pop().split('.')[0]);
							AME.showMessage('The book download is finished. Click the "Install" button to install the book.', 'info', true, null);
						}
						else{
							config.isDownloading = false;
							// Reset current downloading book cdpId.
  							config.cdpId = '';
							try{
								delete_Folder(tempDownloadPath);
							}
							catch(e){
							}
							finally{
								AME.hideStatusBar();
								// config.prompts.alert(null, AME.getTitle(), "Download is cancelled");
								AME.showMessage('The book download is cancelled.', 'info', true, null);
								document.getElementById("doc-viewer-azd").contentWindow.enableDownloadButton(httpLocation.split('/').pop().split('.')[0]);
							}
						}
					} 
				}
			  }
	
			config.obj_Persist.saveURI(obj_URI,null,null,null,null,obj_TargetFile);
		} catch (e) {
			dump('Error while downloading: ' + e);
		}
	}
	
	var cancel = function () {
		var self = this;
		
		config.obj_Persist.cancelSave();
	}
	
	return {
		config: config,
		init: init,
		downloadFile: downloadFile,
		cancel: cancel
	}
}();